// lnxadapt.cpp

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fnmatch.h>
#include <ctype.h>
#include <iconv.h>
#include "lnxadapt.h"

/*
static int alt2koi[128] = {225,226,247,231,228,229,246,250,233,234,235,236,237,
	238,239,240,242,243,244,245,230,232,227,254,251,253,255,249,248,252,
	224,241,193,194,215,199,196,197,214,218,201,202,203,204,205,206,207,
	208,144,145,146,129,135,178,180,167,166,181,161,168,174,173,172,131,
	132,137,136,134,128,138,175,176,171,165,187,184,177,160,190,185,186,
	182,183,170,169,162,164,189,188,133,130,141,140,142,143,139,210,211,
	212,213,198,200,195,222,219,221,223,217,216,220,192,209,179,163,153,
	152,147,155,159,151,156,149,158,150,191,157,148,154
};
*/

static int alt2win[128] = {192,193,194,195,196,197,198,199,200,201,202,203,204,
	205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,
	222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,
	239,45,45,45,166,43,166,166,172,172,166,166,172,45,45,45,172,76,43,84,
	43,45,43,166,166,76,227,166,84,166,61,43,166,166,84,84,76,76,45,227,43,
	43,45,45,45,45,166,166,45,240,241,242,243,244,245,246,247,248,249,250,
	251,252,253,254,255,168,184,170,186,175,191,161,162,176,149,183,118,
	185,164,166,160
};

char *strupr(char *s)
{
	while (*s) {
		*s = (char)toupper((unsigned char)*s);
		s++;
	}
	return s;
} // strupr

int GetPrivateProfileString(char *sect, char *name, char *dfl, char *value,
		int length, char *file)
{
	FILE *f;
	char *secthdr;
	char buf[256];
	int searchres;
	
	f = fopen(file, "r");
	if (f == NULL) {
		perror(file);
		return 0;
	}

	secthdr = (char *)malloc(strlen(sect) + 3);
	strcpy(secthdr, "[");
	strcat(secthdr, sect);
	strcat(secthdr, "]");
	searchres = 0;
	while (fgets(buf, 256, f)) {
		size_t bufln;
		bufln = strlen(buf);
		if (bufln > 0)
			if (buf[bufln - 1] == '\n')
				buf[bufln - 1] = '\0';
		if (strcmp(buf, secthdr) == 0) {
			searchres = 1;
			break;
		}
	}
	free(secthdr);
	
	if (searchres) {
		char *searchstr;
		size_t sl;
		sl = strlen(name) + 1;
		searchstr = (char *)malloc(sl + 1);
		strcpy(searchstr, name);
		strcat(searchstr, "=");
		searchres = 0;
		while (fgets(buf, 256, f)) {
			size_t bufln;
			bufln = strlen(buf);
			if (bufln > 0)
				if (buf[bufln - 1] == '\n')
					buf[bufln - 1] = '\0';
			if (*buf == '[')
				break;
			if (*buf == ';')
				continue;
			if (strncmp(buf, searchstr, sl) == 0) {
				strncpy(value, buf + sl, length);
				searchres = 1;
				break;
			}
		}
		free(searchstr);
	}

	fclose(f);
	if (searchres)
		return strlen(value);
	else {
		strncpy(value, dfl, length);
		return 0;
	}
} // GetPrivateProfileString

int GetPrivateProfileInt(char *sect, char *name, int dfl, char *file)
{
	char buf[256];
	int cnt, value;
	cnt = GetPrivateProfileString(sect, name, "", buf, 256, file);
	if (cnt == 0)
		return dfl;
	cnt = sscanf(buf, "%d", &value);
	if (cnt != 1)
		return dfl;
	else
		return value;
} // GetPrivateProfileInt

bool OemToChar(char *src, char *dst)
{
	/*
	iconv_t cd;
	size_t cnt, insz, outsz;
	int error;
	cd = iconv_open("CP1251", "CP866");
	if (cd == (iconv_t)(-1)) {
		perror("iconv_open");
		strcpy(dst, src);
		return;
	}
	insz = strlen(src) + 1;
	outsz = insz;
	cnt = iconv(cd, &src, &insz, &dst, &outsz);
	if (cnt == (size_t)(-1))
		perror("iconv");
	error = iconv_close(cd);
	if (error)
		perror("iconv_close");
	*/
	int *rtbl = alt2win;
	unsigned int idx;
	while (*src) {
		idx = (unsigned char)*src;
		*dst = idx < 128 ? *src : (char)rtbl[idx - 128];
		dst++;
		src++;
	}
	return true;
} // OemToChar

bool IsPktName(char *filename)
{
	return fnmatch("*.[Pp][Kk][Tt]", filename, 0) == 0;
} // IsPktName

int DeleteFile(char *filename)
{
	return unlink(filename);
} // DeleteFile
