// test_tosser.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

char	logfilename[256];

#include "libPalmDB.h"
#include "FidoLib.h"

#include <stdio.h>
#include <string.h>

#ifdef __LINUX__
#include <sys/types.h>
#include <dirent.h>
#include "lnxadapt.h"
#endif

static char	config_ini[256],
		pkt_inbound[256],
		pkt_pdb[256],
		filename[256],
		buf[256],
		pktfname[256];

static long buflen;

static char bbuf[65536];
static long bbuflen;

static char areaname[1024][128];
static long areacount=0;

static long log_enabled, pkt_deleted, pkt_count, ipkt_count;

static void load_area_list(char* cfg)
{
	FILE *fl;

	fl=fopen(cfg,"rt");

	char buf[256];char st;
	st=0;

	memset(areaname,0,1024*128);

	while(!feof(fl))
	{
		if(fscanf(fl,"%s",buf)>0)
		{
			if(st==0)
			{
				if(strcmp(buf,"[area_list]")==0)
					st=1;
			}
			else
			{
				strupr(buf);
				strcpy(areaname[areacount++],buf);
			};
		};
	};
	fclose(fl);
};

#ifdef __LINUX__
int main(int argc, char *argv[])
#else
int _tmain(int argc, _TCHAR* argv[])
#endif
{
	long i,j;

	CPalmDB cpdb;
	CFidoLib cfl;

#ifndef __LINUX__
	WIN32_FIND_DATA finddata;
	HANDLE hfile;

	GetModuleFileName(NULL,filename,256);

	i=0;j=-1;
   	while(filename[i])
	{
		if(filename[i]=='\\')
			j=i;
		i++;
	};

	if(j>0)
		filename[j+1]=0;
	else
		return -28;

	strcpy(config_ini,filename);
	add_last_slash(config_ini);
	strcat(config_ini,"toss_cfg.ini");
#else
	strcpy(config_ini, CONFIG_FILE);
#endif

	if(!is_file_present(config_ini))
	{
#ifndef __LINUX__
		printf("Error. File:\n%s\nnot found in current directiry\n",config_ini);
#else
		printf("Error. File:\n%s\nnot found.\n",config_ini);
#endif
		return -28;
	};

	buflen=GetPrivateProfileString("directories","inbound","",buf,256,config_ini);

	if(buflen==0 || buflen==254 || buflen==255)
	{
		printf("%s: Error. Can`t read inbound parametr in ini file.\n",config_ini);
		return -28;
	};
    
	add_last_slash(buf);
	strcpy(pkt_inbound,buf);

	buflen=GetPrivateProfileString("directories","tossed_pdb","",buf,256,config_ini);

	if(buflen==0 || buflen==254 || buflen==255)
	{
		printf("%s: Error. Can`t read tossed_pdb parametr in ini file.\n",config_ini);
		return -28;
	};

	if(!IsDirPresent(pkt_inbound))
	{
		printf("%s: The 'inbound' dir is absent.\n", pkt_inbound);
		return -28;
	};

    
	add_last_slash(buf);
	strcpy(pkt_pdb,buf);

	if(!IsDirPresent(pkt_pdb))
	{
		printf("%s: The 'tossed_pdb' dir is absent.\n", pkt_pdb);
		return -28;
	};

	buflen=GetPrivateProfileInt("options","auto_fill_area_list",1,config_ini);
	if(buflen==0)
		load_area_list(config_ini);

	pkt_deleted=GetPrivateProfileInt("options","delete_pkt_after_toss",1,config_ini);
	
	buflen=GetPrivateProfileString("options","log_file_name","",buf,256,config_ini);
	if(buflen==0 || buflen==254 || buflen==255)
	{
		printf("%s: Error. Can`t read log_file_name parametr in ini file. Loging disabled.\n",config_ini);
		log_enabled=0;
	}
	else
	{
#ifndef __LINUX__
		strcpy(logfilename,pkt_pdb);
		strcat(logfilename,buf);
#else
		strcpy(logfilename, buf);
#endif
		log_enabled=1;
	};

	
	pkt_count=0;
	ipkt_count=0;

	if(log_enabled)
	{
//		add_to_log(logfilename,"------------------------------------------------------------------");
		add_to_log(logfilename,"  palmtoss.exe");
	};

//     
#ifndef __LINUX__
	strcpy(buf,pkt_inbound);
	strcat(buf,"*.pkt");

	hfile=FindFirstFile(buf,&finddata);

	if(hfile!=0 && hfile!=(HANDLE)0xFFFFFFFF)
	{
		sprintf(buf,"fido_%x_base",time(NULL));
		cpdb.CreatePDB(buf,0x0008,1,"fido","GaUs");

		do
		{
			if(!(finddata.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY))
			{
				strcpy(pktfname, finddata.cFileName);
#else
	DIR *dir;
	dir = opendir(pkt_inbound);
	if (dir)
	{
		sprintf(buf,"fido_%lx_base",time(NULL));
		cpdb.CreatePDB(buf,0x0008,1,"fido","GaUs");

		do
		{
			struct dirent *de;
			de = readdir(dir);
			if (de == NULL)
				break;
			if (IsPktName(de->d_name))
			{
				strcpy(pktfname, de->d_name);
#endif

				if(log_enabled)
				{
					sprintf(buf,"  %s",pktfname);
					add_to_log(logfilename,buf);
				};

				printf("tossing packet: %s\n",pktfname);

				cfl.Free();
				strcpy(buf,pkt_inbound);
				strcat(buf,pktfname);
				cfl.OpenPackets(buf);

				ipkt_count++;

				for(i=0;i<cfl.GetPacketsNum();i++)
				{
					if(areacount)
					{
						char* t;
						t=cfl.GetPackect(i)->area;
						for(int j=0;j<areacount;j++)
							if(strcmp(t,areaname[j])==0)
							{
								bbuflen=cfl.pktToBuf(bbuf,i);
								if(bbuflen)
								{
									cpdb.AddRecord((unsigned char*)bbuf,bbuflen);
									pkt_count++;
								};
							};
					}
					else
					{
						bbuflen=cfl.pktToBuf(bbuf,i);
						if(bbuflen)
						{
							cpdb.AddRecord((unsigned char*)bbuf,bbuflen);
							pkt_count++;
						};
					};
				};
				if(pkt_deleted)
				{
					sprintf(bbuf,"  %s",pktfname);
					add_to_log(logfilename,bbuf);
					DeleteFile(buf);
				};
			};
		}
#ifndef __LINUX__
		while(FindNextFile(hfile,&finddata));
#else
		while (true);
#endif

		if(log_enabled)
		{
			sprintf(buf,"   %ld, : %ld",ipkt_count,pkt_count);
			add_to_log(logfilename,buf);
		};

		if(pkt_count)
		{
			strcpy(filename,pkt_pdb);
			sprintf(buf,"fido%lx.pdb",(unsigned long)time(NULL));
			strcat(filename,buf);
			cpdb.SortByStr(8);
			cpdb.SavePDB(filename);

			if(log_enabled)
			{
				sprintf(bbuf," : %s",buf);
				add_to_log(logfilename,bbuf);
			};
		};
	};

	if(log_enabled)
	{
		add_to_log(logfilename,"  palmtoss.exe\n-----------------------------------------------------------\n");
	};


	return 0;
}

